<?php

/* * *************************************************************
 *  Copyright notice
*
*  (c) 2011 exabis internet solutions <info@exabis.at>
*  All rights reserved
*
*  You can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This module is based on the Collaborative Moodle Modules from
*  NCSA Education Division (http://www.ncsa.uiuc.edu)
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
* ************************************************************* */


require_once dirname(__FILE__) . '/inc.php';
require_once dirname(__FILE__) . '/lib/div.php';

global $COURSE, $CFG, $OUTPUT, $USER;



$courseid = required_param('courseid', PARAM_INT);
$subjectid = optional_param('subjectid', 0, PARAM_INT);
$action = optional_param('action', 0, PARAM_INT);
$calendarinput = optional_param('calendarinput', 'none', PARAM_TEXT);
$studentid=optional_param('studentid', 0, PARAM_INT);
$druck = optional_param('druck', 0, PARAM_INT);

require_login($courseid);

$context = get_context_instance(CONTEXT_COURSE, $courseid);

if (has_capability('block/exacomp:teacher', $context)) {
	$role = "teacher";
	$stundentselect = block_exacomp_studentselector(get_role_users(5, $context),$studentid,"/blocks/exacomp/learningagenda.php?courseid=".$courseid);
} else {
	$role = "student";
	$stundentselect="";
	$studentid=$USER->id;
}



$url = '/blocks/exacomp/learningagenda.php?courseid=' . $courseid;
$PAGE->set_url($url);
$PAGE->requires->css('/blocks/exacomp/styles.css');

if($druck == 0){

	if($role == "student") block_exacomp_print_header("student", "studenttabcompetencesagenda");
	if($role == "teacher") block_exacomp_print_header("teacher", "studenttabcompetencesagenda");
}
//one week = 604 800 sec
$week = $action * 604800;

//if date is selecte by calendar, timestamp is calculated
if(strcmp($calendarinput, 'none')!=0){
	$datecal =  explode ("-", $calendarinput);
	$timecal = mktime(0,0,0,$datecal[1],$datecal[2],$datecal[0]); 
}

$sql="SELECT concat( tmm.id, '_', emm.id ) AS id, subj.title AS subject, subj.number as subnumb, examp.title AS example, cat.title as cat,
exameval.starttime as start, exameval.endtime as end, exameval.student_evaluation as evaluate, exameval.teacher_evaluation as tevaluate, descr.title
FROM {block_exacompsubjects} subj
INNER JOIN {block_exacomptopics} top ON top.subjid = subj.id
INNER JOIN {block_exacompdescrtopic_mm} tmm ON tmm.topicid = top.id
INNER JOIN {block_exacompdescriptors} descr ON descr.id = tmm.descrid
INNER JOIN {block_exacompdescrexamp_mm} emm ON emm.descrid = descr.id
INNER JOIN {block_exacompexamples} examp ON examp.id = emm.exampid
INNER JOIN {block_exacompexameval} exameval ON exameval.exampleid = emm.exampid
INNER JOIN {block_exacompcategories} cat ON top.cat = cat.id
WHERE exameval.studentid =?";

$rows = $DB->get_records_sql($sql, array($studentid));

$results = array();	
foreach($rows as $row){
	if(isset($row->start))
		$results[] = $row;
}

//if date is selected by calendar use this time 
if(isset($timecal)) $time = $timecal;
//if actual date is used, add $week to browse through the weeks
else $time = time()+$week;

$days = array('MO','DI','MI','DO','FR');

//calculate dates of whole week from current day
$actday = date('w', $time);
if($actday == -1) $actday = 6;
$temps = array(-1+$actday,-2+$actday,-3+$actday,-4+$actday,-5+$actday);

$dates = array();
foreach($temps as $temp){
	$dates[] = getdate( $time-$temp*86400);
}

//convert the dates to timestamps
$weekdays = array();
for($i = 0; $i <5; $i++){
	$boxdate = mktime(0,0,0, $dates[$i]['mon'], $dates[$i]['mday'], $dates[$i]['year']);
	$weekdays[get_string($days[$i], 'block_exacomp')] = date($boxdate);
}
//in $weekdays all timestamps from actual week are stored now
//add subjects, examples and descriptors to each day
$data = array();
$count = 0;
$sumcount = $count;
foreach($weekdays as $weekday=>$tag){
	foreach($results as $result){
		$example = new stdClass();
		if($result->start <= $tag && ($result->end >= $tag || !isset($result->end))){	
			$count++;
			$example->title = $result->example;
			$example->desc = $result->title;
			$example->evaluate = $result->evaluate;
			$example->numb = $result->subnumb;
			$example->cat = $result->cat;
			if(isset($result->tevaluate)){
				$example->tevaluate = $result->tevaluate;
			}else{
				$example->tevaluate = 0;
			}
			$data[$weekday][$result->subject][] = $example;
		}
		$data[$weekday]['date'] =  date("d M Y", $tag);
	}
	if($count == 0)
		$data[$weekday]["no example available"][] = new stdClass();
	$sumcount += $count;
	$count = 0;	
}

$output = $PAGE->get_renderer('block_exacomp');	
if($druck == 0){
	echo $output->form_week_learningagenda($stundentselect,$action, $studentid, $druck);
	
	if($sumcount!=0)	
		echo $output->render_learning_agenda($data, $weekdays);
	else {
		if($studentid == 0)
			echo '<h2>'.get_string('schueler_waehlen', 'block_exacomp').'</h2>';
		else echo '<h2>'.get_string('keine_lernagenden', 'block_exacomp').'</h2>';
	} 
		
}else{
	echo $output->print_header();
	echo $output->form_week_learningagenda($stundentselect,$action, $studentid, $druck);

	$user = $DB->get_record('user', array('id'=>$studentid)); 
	echo $output->print_view_learning_agenda($data, $user->firstname.' '.$user->lastname);
	echo $output->print_footer();
}
?>
